
;CodeVisionAVR C Compiler V3.12 Advanced
;(C) Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Build configuration    : Debug
;Chip type              : ATmega64A
;Program type           : Application
;Clock frequency        : 8.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External RAM size      : 0
;Data Stack size        : 1024 byte(s)
;Heap size              : 0 byte(s)
;Promote 'char' to 'int': Yes
;'char' is unsigned     : Yes
;8 bit enums            : Yes
;Global 'const' stored in FLASH: Yes
;Enhanced function parameter passing: Yes
;Enhanced core instructions: On
;Automatic register allocation for global variables: On
;Smart register allocation: On

	#define _MODEL_SMALL_

	#pragma AVRPART ADMIN PART_NAME ATmega64A
	#pragma AVRPART MEMORY PROG_FLASH 65536
	#pragma AVRPART MEMORY EEPROM 2048
	#pragma AVRPART MEMORY INT_SRAM SIZE 4096
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x100

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0100
	.EQU __SRAM_END=0x10FF
	.EQU __DSTACK_SIZE=0x0400
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTW2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD2FN
	LDI  R26,LOW(2*@0+(@1))
	LDI  R27,HIGH(2*@0+(@1))
	LDI  R24,BYTE3(2*@0+(@1))
	LDI  R25,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	PUSH R26
	PUSH R27
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	POP  R27
	POP  R26
	ICALL
	.ENDM

	.MACRO __CALL2EX
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	CALL __EEPROMRDD
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1STACK
	IN   R30,SPL
	IN   R31,SPH
	ADIW R30,@0+1
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z
	MOVW R30,R0
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF _freq1=R5
	.DEF _freq0=R4
	.DEF _tcnt1_start_value=R6
	.DEF _tcnt1_start_value_msb=R7
	.DEF _tcnt0_start_value=R9
	.DEF __lcd_x=R8
	.DEF __lcd_y=R11
	.DEF __lcd_maxx=R10

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  _timer1_ovf_isr
	JMP  _timer0_comp_isr
	JMP  _timer0_ovf_isr
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;GLOBAL REGISTER VARIABLES INITIALIZATION
__REG_VARS:
	.DB  0x5,0x5,0x0,0x0
	.DB  0x0,0x0

_0x0:
	.DB  0x55,0x42,0x4F,0x41,0x52,0x44,0x2E,0x69
	.DB  0x72,0x0,0x43,0x68,0x61,0x6E,0x67,0x65
	.DB  0x20,0x4F,0x43,0x31,0x41,0x20,0x56,0x61
	.DB  0x6C,0x75,0x65,0x73,0x21,0x0,0x43,0x68
	.DB  0x61,0x6E,0x67,0x65,0x20,0x4F,0x43,0x31
	.DB  0x42,0x20,0x56,0x61,0x6C,0x75,0x65,0x73
	.DB  0x21,0x0,0x43,0x68,0x61,0x6E,0x67,0x65
	.DB  0x20,0x4F,0x43,0x31,0x43,0x20,0x56,0x61
	.DB  0x6C,0x75,0x65,0x73,0x21,0x0,0x43,0x68
	.DB  0x61,0x6E,0x67,0x65,0x20,0x50,0x41,0x30
	.DB  0x20,0x56,0x61,0x6C,0x75,0x65,0x73,0x21
	.DB  0x0,0x4F,0x43,0x2E,0x2E,0x31,0x41,0x2E
	.DB  0x31,0x42,0x2E,0x31,0x43,0x20,0x20,0x50
	.DB  0x41,0x30,0x0,0x66,0x3D,0x20,0x20,0x25
	.DB  0x32,0x64,0x20,0x25,0x32,0x64,0x20,0x25
	.DB  0x32,0x64,0x20,0x20,0x25,0x32,0x64,0x20
	.DB  0x6B,0x48,0x7A,0x0,0x44,0x43,0x3D,0x20
	.DB  0x25,0x32,0x64,0x20,0x25,0x32,0x64,0x20
	.DB  0x25,0x32,0x64,0x20,0x20,0x25,0x32,0x64
	.DB  0x20,0x25,0x25,0x0
_0x2020003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x06
	.DW  0x04
	.DW  __REG_VARS*2

	.DW  0x0A
	.DW  _0x3
	.DW  _0x0*2

	.DW  0x14
	.DW  _0x3+10
	.DW  _0x0*2+10

	.DW  0x14
	.DW  _0x3+30
	.DW  _0x0*2+30

	.DW  0x14
	.DW  _0x3+50
	.DW  _0x0*2+50

	.DW  0x13
	.DW  _0x3+70
	.DW  _0x0*2+70

	.DW  0x12
	.DW  _0x3+89
	.DW  _0x0*2+89

	.DW  0x02
	.DW  __base_y_G101
	.DW  _0x2020003*2

_0xFFFFFFFF:
	.DW  0

#define __GLOBAL_INI_TBL_PRESENT 1

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,LOW(__SRAM_START)
	LDI  R27,HIGH(__SRAM_START)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x500

	.CSEG
;/*******************************************************
;This project was created by the http://www.uboard.ir
;
;Author          : Reza Asadi
;IDE             : CodeVisionAVR
;Project         : PWM Using PWM mode 7 of timer/counter1
;Version         : 1
;Date            : 16/11/2020
;Chip type               : ATmega64A
;Core Clock frequency    : 8.000000 MHz
;Comments        : This project is a exercise for
;                  making PWM with timer.
;
;*******************************************************/
;#define F_CPU 8000000UL
;
;#define next_pwm_change_key                (PINE & (1<<7))
;#define duty_cycle_decrease_key            (PINE & (1<<4))
;#define duty_cycle_increase_key            (PINE & (1<<5))
;#define frequency_decrease_key            (PINE & (1<<6))
;#define frequency_increase_key            (PINB & (1<<0))
;
;#define oc1a_pwm_channel    0
;#define oc1b_pwm_channel    1
;#define oc1c_pwm_channel    2
;#define pa0_pwm_channel		3
;
;
;#define timer1_mode_7_top_value        1023
;#define timer0_mode_0_top_value        255
;#define timer1_clock_frequency        1000000
;#define timer0_clock_frequency        1000000
;
;#include <mega64.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
;#include <delay.h>
;#include <stdio.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif
;#include <alcd.h>
;
;unsigned char freq1=5, freq0=5; // frequencies in kHz
;unsigned int tcnt1_start_value=0;
;unsigned char tcnt0_start_value=0;
;
;
;interrupt [TIM1_OVF] void timer1_ovf_isr(void)
; 0000 002D {

	.CSEG
_timer1_ovf_isr:
; .FSTART _timer1_ovf_isr
; 0000 002E     TCNT1=tcnt1_start_value;
	__OUTWR 6,7,44
; 0000 002F }
	RETI
; .FEND
;
;interrupt [TIM0_OVF] void timer0_ovf_isr(void)
; 0000 0032 {
_timer0_ovf_isr:
; .FSTART _timer0_ovf_isr
; 0000 0033     TCNT0=tcnt0_start_value;
	OUT  0x32,R9
; 0000 0034     PORTA |= (1<<0);  // set PA.0 at overflow
	SBI  0x1B,0
; 0000 0035 }
	RETI
; .FEND
;
;interrupt [TIM0_COMP] void timer0_comp_isr(void)
; 0000 0038 {
_timer0_comp_isr:
; .FSTART _timer0_comp_isr
; 0000 0039     PORTA &=~ (1<<0);  // clear PA.0 at Compare Match
	CBI  0x1B,0
; 0000 003A }
	RETI
; .FEND
;
;void main(void)
; 0000 003D {
_main:
; .FSTART _main
; 0000 003E 	char oc1a_duty_cycle=10, oc1b_duty_cycle=10, oc1c_duty_cycle=10;
; 0000 003F 	char pa0_duty_cycle=10;
; 0000 0040 	unsigned int ocr1a_value= (unsigned int) (tcnt1_start_value + ((oc1a_duty_cycle * 0.01) * (timer1_mode_7_top_value - tc ...
; 0000 0041 	unsigned int ocr1b_value= (unsigned int) (tcnt1_start_value + ((oc1b_duty_cycle * 0.01) * (timer1_mode_7_top_value - tc ...
; 0000 0042 	unsigned int ocr1c_value= (unsigned int) (tcnt1_start_value + ((oc1c_duty_cycle * 0.01) * (timer1_mode_7_top_value - tc ...
; 0000 0043 	unsigned char ocr0_value= (unsigned char)(tcnt0_start_value + ((pa0_duty_cycle  * 0.01) * (timer0_mode_0_top_value - tc ...
; 0000 0044 
; 0000 0045 	unsigned char pwm_channel=oc1a_pwm_channel;
; 0000 0046 	char lcd_str[21];
; 0000 0047 
; 0000 0048 	DDRB=(1<<DDB7) | (1<<DDB6) | (1<<DDB5);
	SBIW R28,27
	LDI  R30,LOW(0)
	STD  Y+21,R30
;	oc1a_duty_cycle -> R17
;	oc1b_duty_cycle -> R16
;	oc1c_duty_cycle -> R19
;	pa0_duty_cycle -> R18
;	ocr1a_value -> R20,R21
;	ocr1b_value -> Y+25
;	ocr1c_value -> Y+23
;	ocr0_value -> Y+22
;	pwm_channel -> Y+21
;	lcd_str -> Y+0
	LDI  R17,10
	LDI  R16,10
	LDI  R19,10
	LDI  R18,10
	CALL SUBOPT_0x0
	CALL SUBOPT_0x1
	CALL SUBOPT_0x2
	MOV  R30,R9
	LDI  R31,0
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x3
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x4
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x5
	POP  R26
	POP  R27
	CALL SUBOPT_0x6
	LDI  R30,LOW(224)
	OUT  0x17,R30
; 0000 0049 	DDRA |= (1<<DDA0);
	SBI  0x1A,0
; 0000 004A 	PORTE |= (1<<7)|(1<<6)|(1<<5)|(1<<4);
	IN   R30,0x3
	ORI  R30,LOW(0xF0)
	OUT  0x3,R30
; 0000 004B 	PORTB |= (1<<0);
	SBI  0x18,0
; 0000 004C 
; 0000 004D 	// Timer/Counter 1 initialization
; 0000 004E 	// Clock source: System Clock
; 0000 004F 	// Clock value: 1000.000 kHz
; 0000 0050 	// Mode: Fast PWM top=0x03FF=1023
; 0000 0051 	// OC1A/B/C output: Non-Inverted PWM
; 0000 0052 	// Output Pulse(s):
; 0000 0053 	// OC1A Period: 1 ms Width: 0.1 ms
; 0000 0054 	// OC1B Period: 1 ms Width: 0.1 ms
; 0000 0055 	// OC1C Period: 1 ms Width: 0.1 ms
; 0000 0056 	TCCR1A=(1<<COM1A1) | (0<<COM1A0) | (1<<COM1B1) | (0<<COM1B0) | (1<<COM1C1) | (0<<COM1C0) | (1<<WGM11) | (1<<WGM10);
	LDI  R30,LOW(171)
	OUT  0x2F,R30
; 0000 0057 	TCCR1B=(0<<ICNC1) | (0<<ICES1) | (0<<WGM13) | (1<<WGM12) | (0<<CS12) | (1<<CS11) | (0<<CS10);
	LDI  R30,LOW(10)
	OUT  0x2E,R30
; 0000 0058 	TCNT1=tcnt1_start_value;
	__OUTWR 6,7,44
; 0000 0059 	OCR1AH= ocr1a_value >> 8;
	CALL SUBOPT_0x7
; 0000 005A 	OCR1AL= ocr1a_value & 0xFF;
; 0000 005B 	OCR1BH= ocr1b_value >> 8;
	CALL SUBOPT_0x8
; 0000 005C 	OCR1BL= ocr1b_value & 0xFF;
; 0000 005D 	OCR1CH= ocr1c_value >> 8;
	CALL SUBOPT_0x9
; 0000 005E 	OCR1CL= ocr1c_value & 0xFF;
; 0000 005F 
; 0000 0060 	// Timer1 Overflow Interrupt: On
; 0000 0061 	TIMSK |= (1<<TOIE1);
	IN   R30,0x37
	ORI  R30,4
	OUT  0x37,R30
; 0000 0062 
; 0000 0063 	// Timer/Counter 0 initialization
; 0000 0064 	// Clock source: System Clock
; 0000 0065 	// Clock value: 1000.000 kHz
; 0000 0066 	// Mode: Normal top=0xFF
; 0000 0067 	// OC0 output: Disconnected
; 0000 0068 	ASSR=0<<AS0;
	LDI  R30,LOW(0)
	OUT  0x30,R30
; 0000 0069 	TCCR0=(0<<WGM00) | (0<<COM01) | (0<<COM00) | (0<<WGM01) | (0<<CS02) | (1<<CS01) | (0<<CS00);
	LDI  R30,LOW(2)
	OUT  0x33,R30
; 0000 006A 	TCNT0=tcnt0_start_value;
	OUT  0x32,R9
; 0000 006B 	OCR0=ocr0_value;
	LDD  R30,Y+22
	OUT  0x31,R30
; 0000 006C 
; 0000 006D 	// Timer0 Overflow Interrupt: On
; 0000 006E 	// Timer0 Compare Match Interrupt: On
; 0000 006F 	TIMSK |= (1<<OCIE0) | (1<<TOIE0);
	IN   R30,0x37
	ORI  R30,LOW(0x3)
	OUT  0x37,R30
; 0000 0070 
; 0000 0071 	#asm("sei")
	sei
; 0000 0072 
; 0000 0073 	lcd_init(20);
	LDI  R26,LOW(20)
	CALL _lcd_init
; 0000 0074 	lcd_clear();
	CALL _lcd_clear
; 0000 0075 	lcd_puts("UBOARD.ir");
	__POINTW2MN _0x3,0
	CALL _lcd_puts
; 0000 0076 	delay_ms(1500);
	LDI  R26,LOW(1500)
	LDI  R27,HIGH(1500)
	CALL _delay_ms
; 0000 0077 
; 0000 0078 	while (1)
_0x4:
; 0000 0079 	{
; 0000 007A 		if (!next_pwm_change_key)
	SBIC 0x1,7
	RJMP _0x7
; 0000 007B 		{
; 0000 007C 			delay_ms(50);
	CALL SUBOPT_0xA
; 0000 007D 			while (!next_pwm_change_key);
_0x8:
	SBIS 0x1,7
	RJMP _0x8
; 0000 007E 			if      (pwm_channel==oc1a_pwm_channel) pwm_channel=oc1b_pwm_channel;
	LDD  R30,Y+21
	CPI  R30,0
	BRNE _0xB
	LDI  R30,LOW(1)
	RJMP _0x4F
; 0000 007F 			else if (pwm_channel==oc1b_pwm_channel) pwm_channel=oc1c_pwm_channel;
_0xB:
	LDD  R26,Y+21
	CPI  R26,LOW(0x1)
	BRNE _0xD
	LDI  R30,LOW(2)
	RJMP _0x4F
; 0000 0080 			else if (pwm_channel==oc1c_pwm_channel) pwm_channel=pa0_pwm_channel;
_0xD:
	LDD  R26,Y+21
	CPI  R26,LOW(0x2)
	BRNE _0xF
	LDI  R30,LOW(3)
	RJMP _0x4F
; 0000 0081 			else if (pwm_channel==pa0_pwm_channel)  pwm_channel=oc1a_pwm_channel;
_0xF:
	LDD  R26,Y+21
	CPI  R26,LOW(0x3)
	BRNE _0x11
	LDI  R30,LOW(0)
_0x4F:
	STD  Y+21,R30
; 0000 0082 		}
_0x11:
; 0000 0083 		else if (!duty_cycle_decrease_key)
	RJMP _0x12
_0x7:
	SBIC 0x1,4
	RJMP _0x13
; 0000 0084 		{
; 0000 0085 			delay_ms(50);
	CALL SUBOPT_0xA
; 0000 0086 			while (!duty_cycle_decrease_key);
_0x14:
	SBIS 0x1,4
	RJMP _0x14
; 0000 0087 			if(pwm_channel==oc1a_pwm_channel)
	LDD  R30,Y+21
	CPI  R30,0
	BRNE _0x17
; 0000 0088 			{
; 0000 0089 				oc1a_duty_cycle-=10;
	SUBI R17,LOW(10)
; 0000 008A 				if(oc1a_duty_cycle<10) oc1a_duty_cycle=10;
	CPI  R17,10
	BRSH _0x18
	LDI  R17,LOW(10)
; 0000 008B 				ocr1a_value= (unsigned int) (tcnt1_start_value + ((oc1a_duty_cycle * 0.01) * (timer1_mode_7_top_value - tcnt1_start_ ...
_0x18:
	CALL SUBOPT_0x0
; 0000 008C 				OCR1AH= ocr1a_value >> 8;
	CALL SUBOPT_0x7
; 0000 008D 				OCR1AL= ocr1a_value & 0xFF;
; 0000 008E 			}
; 0000 008F 			else if (pwm_channel==oc1b_pwm_channel)
	RJMP _0x19
_0x17:
	LDD  R26,Y+21
	CPI  R26,LOW(0x1)
	BRNE _0x1A
; 0000 0090 			{
; 0000 0091 				oc1b_duty_cycle-=10;
	SUBI R16,LOW(10)
; 0000 0092 				if(oc1b_duty_cycle<10) oc1b_duty_cycle=10;
	CPI  R16,10
	BRSH _0x1B
	LDI  R16,LOW(10)
; 0000 0093 				ocr1b_value= (unsigned int) (tcnt1_start_value + ((oc1b_duty_cycle * 0.01) * (timer1_mode_7_top_value - tcnt1_start_ ...
_0x1B:
	CALL SUBOPT_0x1
; 0000 0094 				OCR1BH= ocr1b_value >> 8;
	CALL SUBOPT_0x8
; 0000 0095 				OCR1BL= ocr1b_value & 0xFF;
; 0000 0096 			}
; 0000 0097 			else if (pwm_channel==oc1c_pwm_channel)
	RJMP _0x1C
_0x1A:
	LDD  R26,Y+21
	CPI  R26,LOW(0x2)
	BRNE _0x1D
; 0000 0098 			{
; 0000 0099 				oc1c_duty_cycle-=10;
	SUBI R19,LOW(10)
; 0000 009A 				if(oc1c_duty_cycle<10) oc1c_duty_cycle=10;
	CPI  R19,10
	BRSH _0x1E
	LDI  R19,LOW(10)
; 0000 009B 				ocr1c_value= (unsigned int) (tcnt1_start_value + ((oc1c_duty_cycle * 0.01) * (timer1_mode_7_top_value - tcnt1_start_ ...
_0x1E:
	CALL SUBOPT_0x2
; 0000 009C 				OCR1CH= ocr1c_value >> 8;
	CALL SUBOPT_0x9
; 0000 009D 				OCR1CL= ocr1c_value & 0xFF;
; 0000 009E 			}
; 0000 009F 			else if (pwm_channel==pa0_pwm_channel)
	RJMP _0x1F
_0x1D:
	LDD  R26,Y+21
	CPI  R26,LOW(0x3)
	BRNE _0x20
; 0000 00A0 			{
; 0000 00A1 				pa0_duty_cycle-=10;
	SUBI R18,LOW(10)
; 0000 00A2 				if(pa0_duty_cycle<10) pa0_duty_cycle=10;
	CPI  R18,10
	BRSH _0x21
	LDI  R18,LOW(10)
; 0000 00A3 				ocr0_value= (unsigned char)(tcnt0_start_value + ((pa0_duty_cycle  * 0.01) * (timer0_mode_0_top_value - tcnt0_start_v ...
_0x21:
	MOV  R30,R9
	LDI  R31,0
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x3
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x4
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x5
	POP  R26
	POP  R27
	CALL SUBOPT_0x6
; 0000 00A4 				OCR0=ocr0_value;
	LDD  R30,Y+22
	OUT  0x31,R30
; 0000 00A5 			}
; 0000 00A6 		}
_0x20:
_0x1F:
_0x1C:
_0x19:
; 0000 00A7 		else if (!duty_cycle_increase_key)
	RJMP _0x22
_0x13:
	SBIC 0x1,5
	RJMP _0x23
; 0000 00A8 		{
; 0000 00A9 			delay_ms(50);
	CALL SUBOPT_0xA
; 0000 00AA 			while (!duty_cycle_increase_key);
_0x24:
	SBIS 0x1,5
	RJMP _0x24
; 0000 00AB 			if(pwm_channel==oc1a_pwm_channel)
	LDD  R30,Y+21
	CPI  R30,0
	BRNE _0x27
; 0000 00AC 			{
; 0000 00AD 				oc1a_duty_cycle+=10;
	SUBI R17,-LOW(10)
; 0000 00AE 				if(oc1a_duty_cycle>90) oc1a_duty_cycle=90;
	CPI  R17,91
	BRLO _0x28
	LDI  R17,LOW(90)
; 0000 00AF 				ocr1a_value= (unsigned int) (tcnt1_start_value + ((oc1a_duty_cycle * 0.01) * (timer1_mode_7_top_value - tcnt1_start_ ...
_0x28:
	CALL SUBOPT_0x0
; 0000 00B0 				OCR1AH= ocr1a_value >> 8;
	CALL SUBOPT_0x7
; 0000 00B1 				OCR1AL= ocr1a_value & 0xFF;
; 0000 00B2 			}
; 0000 00B3 			else if (pwm_channel==oc1b_pwm_channel)
	RJMP _0x29
_0x27:
	LDD  R26,Y+21
	CPI  R26,LOW(0x1)
	BRNE _0x2A
; 0000 00B4 			{
; 0000 00B5 				oc1b_duty_cycle+=10;
	SUBI R16,-LOW(10)
; 0000 00B6 				if(oc1b_duty_cycle>90) oc1b_duty_cycle=90;
	CPI  R16,91
	BRLO _0x2B
	LDI  R16,LOW(90)
; 0000 00B7 				ocr1b_value= (unsigned int) (tcnt1_start_value + ((oc1b_duty_cycle * 0.01) * (timer1_mode_7_top_value - tcnt1_start_ ...
_0x2B:
	CALL SUBOPT_0x1
; 0000 00B8 				OCR1BH= ocr1b_value >> 8;
	CALL SUBOPT_0x8
; 0000 00B9 				OCR1BL= ocr1b_value & 0xFF;
; 0000 00BA 			}
; 0000 00BB 			else if (pwm_channel==oc1c_pwm_channel)
	RJMP _0x2C
_0x2A:
	LDD  R26,Y+21
	CPI  R26,LOW(0x2)
	BRNE _0x2D
; 0000 00BC 			{
; 0000 00BD 				oc1c_duty_cycle+=10;
	SUBI R19,-LOW(10)
; 0000 00BE 				if(oc1c_duty_cycle>90) oc1c_duty_cycle=90;
	CPI  R19,91
	BRLO _0x2E
	LDI  R19,LOW(90)
; 0000 00BF 				ocr1c_value= (unsigned int) (tcnt1_start_value + ((oc1c_duty_cycle * 0.01) * (timer1_mode_7_top_value - tcnt1_start_ ...
_0x2E:
	CALL SUBOPT_0x2
; 0000 00C0 				OCR1CH= ocr1c_value >> 8;
	CALL SUBOPT_0x9
; 0000 00C1 				OCR1CL= ocr1c_value & 0xFF;
; 0000 00C2 			}
; 0000 00C3 			else if (pwm_channel==pa0_pwm_channel)
	RJMP _0x2F
_0x2D:
	LDD  R26,Y+21
	CPI  R26,LOW(0x3)
	BRNE _0x30
; 0000 00C4 			{
; 0000 00C5 				pa0_duty_cycle+=10;
	SUBI R18,-LOW(10)
; 0000 00C6 				if(pa0_duty_cycle>90) pa0_duty_cycle=90;
	CPI  R18,91
	BRLO _0x31
	LDI  R18,LOW(90)
; 0000 00C7 				ocr0_value= (unsigned char)(tcnt0_start_value + ((pa0_duty_cycle  * 0.01) * (timer0_mode_0_top_value - tcnt0_start_v ...
_0x31:
	MOV  R30,R9
	LDI  R31,0
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x3
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x4
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x5
	POP  R26
	POP  R27
	CALL SUBOPT_0x6
; 0000 00C8 				OCR0=ocr0_value;
	LDD  R30,Y+22
	OUT  0x31,R30
; 0000 00C9 			}
; 0000 00CA 		}
_0x30:
_0x2F:
_0x2C:
_0x29:
; 0000 00CB 		else if (!frequency_decrease_key)
	RJMP _0x32
_0x23:
	SBIC 0x1,6
	RJMP _0x33
; 0000 00CC 		{
; 0000 00CD 			delay_ms(50);
	CALL SUBOPT_0xA
; 0000 00CE 			while (!frequency_decrease_key);
_0x34:
	SBIS 0x1,6
	RJMP _0x34
; 0000 00CF 			if((pwm_channel==oc1a_pwm_channel)||(pwm_channel==oc1b_pwm_channel)||(pwm_channel==oc1c_pwm_channel))
	LDD  R26,Y+21
	CPI  R26,LOW(0x0)
	BREQ _0x38
	CPI  R26,LOW(0x1)
	BREQ _0x38
	CPI  R26,LOW(0x2)
	BRNE _0x37
_0x38:
; 0000 00D0 			{
; 0000 00D1 				freq1--;
	DEC  R5
; 0000 00D2 				if(freq1<1) freq1=1;
	LDI  R30,LOW(1)
	CP   R5,R30
	BRSH _0x3A
	MOV  R5,R30
; 0000 00D3 				tcnt1_start_value=  (unsigned int)  (timer1_mode_7_top_value - (timer1_clock_frequency/(freq1*1000)));
_0x3A:
	CALL SUBOPT_0xB
; 0000 00D4 				ocr1a_value= (unsigned int) (tcnt1_start_value + ((oc1a_duty_cycle * 0.01) * (timer1_mode_7_top_value - tcnt1_start_ ...
; 0000 00D5 				ocr1b_value= (unsigned int) (tcnt1_start_value + ((oc1b_duty_cycle * 0.01) * (timer1_mode_7_top_value - tcnt1_start_ ...
	CALL SUBOPT_0x1
; 0000 00D6 				ocr1c_value= (unsigned int) (tcnt1_start_value + ((oc1c_duty_cycle * 0.01) * (timer1_mode_7_top_value - tcnt1_start_ ...
	CALL SUBOPT_0x2
; 0000 00D7 				OCR1AH= ocr1a_value >> 8;
	CALL SUBOPT_0x7
; 0000 00D8 				OCR1AL= ocr1a_value & 0xFF;
; 0000 00D9 				OCR1BH= ocr1b_value >> 8;
	CALL SUBOPT_0x8
; 0000 00DA 				OCR1BL= ocr1b_value & 0xFF;
; 0000 00DB 				OCR1CH= ocr1c_value >> 8;
	CALL SUBOPT_0x9
; 0000 00DC 				OCR1CL= ocr1c_value & 0xFF;
; 0000 00DD 			}
; 0000 00DE 			else if(pwm_channel==pa0_pwm_channel)
	RJMP _0x3B
_0x37:
	LDD  R26,Y+21
	CPI  R26,LOW(0x3)
	BRNE _0x3C
; 0000 00DF 			{
; 0000 00E0 				freq0--;
	DEC  R4
; 0000 00E1 				if(freq0<4) freq0=4;
	LDI  R30,LOW(4)
	CP   R4,R30
	BRSH _0x3D
	MOV  R4,R30
; 0000 00E2 				tcnt0_start_value= (unsigned char) (timer0_mode_0_top_value - (timer0_clock_frequency/(freq0*1000)));
_0x3D:
	CALL SUBOPT_0xC
; 0000 00E3 				ocr0_value= (unsigned char)(tcnt0_start_value + ((pa0_duty_cycle  * 0.01) * (timer0_mode_0_top_value - tcnt0_start_v ...
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x3
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x4
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x5
	POP  R26
	POP  R27
	CALL SUBOPT_0x6
; 0000 00E4 				OCR0=ocr0_value;
	LDD  R30,Y+22
	OUT  0x31,R30
; 0000 00E5 			}
; 0000 00E6 		}
_0x3C:
_0x3B:
; 0000 00E7 		else if (!frequency_increase_key)
	RJMP _0x3E
_0x33:
	SBIC 0x16,0
	RJMP _0x3F
; 0000 00E8 		{
; 0000 00E9 			delay_ms(50);
	CALL SUBOPT_0xA
; 0000 00EA 			while (!frequency_increase_key);
_0x40:
	SBIS 0x16,0
	RJMP _0x40
; 0000 00EB 			if((pwm_channel==oc1a_pwm_channel)||(pwm_channel==oc1b_pwm_channel)||(pwm_channel==oc1c_pwm_channel))
	LDD  R26,Y+21
	CPI  R26,LOW(0x0)
	BREQ _0x44
	CPI  R26,LOW(0x1)
	BREQ _0x44
	CPI  R26,LOW(0x2)
	BRNE _0x43
_0x44:
; 0000 00EC 			{
; 0000 00ED 				freq1++;
	INC  R5
; 0000 00EE 				if(freq1>10) freq1=10;
	LDI  R30,LOW(10)
	CP   R30,R5
	BRSH _0x46
	MOV  R5,R30
; 0000 00EF 				tcnt1_start_value=  (unsigned int)  (timer1_mode_7_top_value - (timer1_clock_frequency/(freq1*1000)));
_0x46:
	CALL SUBOPT_0xB
; 0000 00F0 				ocr1a_value= (unsigned int) (tcnt1_start_value + ((oc1a_duty_cycle * 0.01) * (timer1_mode_7_top_value - tcnt1_start_ ...
; 0000 00F1 				ocr1b_value= (unsigned int) (tcnt1_start_value + ((oc1b_duty_cycle * 0.01) * (timer1_mode_7_top_value - tcnt1_start_ ...
	CALL SUBOPT_0x1
; 0000 00F2 				ocr1c_value= (unsigned int) (tcnt1_start_value + ((oc1c_duty_cycle * 0.01) * (timer1_mode_7_top_value - tcnt1_start_ ...
	CALL SUBOPT_0x2
; 0000 00F3 				OCR1AH= ocr1a_value >> 8;
	CALL SUBOPT_0x7
; 0000 00F4 				OCR1AL= ocr1a_value & 0xFF;
; 0000 00F5 				OCR1BH= ocr1b_value >> 8;
	CALL SUBOPT_0x8
; 0000 00F6 				OCR1BL= ocr1b_value & 0xFF;
; 0000 00F7 				OCR1CH= ocr1c_value >> 8;
	CALL SUBOPT_0x9
; 0000 00F8 				OCR1CL= ocr1c_value & 0xFF;
; 0000 00F9 			}
; 0000 00FA 			else if(pwm_channel==pa0_pwm_channel)
	RJMP _0x47
_0x43:
	LDD  R26,Y+21
	CPI  R26,LOW(0x3)
	BRNE _0x48
; 0000 00FB 			{
; 0000 00FC 				freq0++;
	INC  R4
; 0000 00FD 				if(freq0>10) freq0=10;
	LDI  R30,LOW(10)
	CP   R30,R4
	BRSH _0x49
	MOV  R4,R30
; 0000 00FE 				tcnt0_start_value= (unsigned char) (timer0_mode_0_top_value - (timer0_clock_frequency/(freq0*1000)));
_0x49:
	CALL SUBOPT_0xC
; 0000 00FF 				ocr0_value= (unsigned char)(tcnt0_start_value + ((pa0_duty_cycle  * 0.01) * (timer0_mode_0_top_value - tcnt0_start_v ...
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x3
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	CALL SUBOPT_0x4
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	CALL SUBOPT_0x5
	POP  R26
	POP  R27
	CALL SUBOPT_0x6
; 0000 0100 				OCR0=ocr0_value;
	LDD  R30,Y+22
	OUT  0x31,R30
; 0000 0101 			}
; 0000 0102 		}
_0x48:
_0x47:
; 0000 0103 
; 0000 0104 		lcd_clear();
_0x3F:
_0x3E:
_0x32:
_0x22:
_0x12:
	CALL _lcd_clear
; 0000 0105 		lcd_gotoxy(0,0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(0)
	CALL _lcd_gotoxy
; 0000 0106 		if(pwm_channel==oc1a_pwm_channel) lcd_puts("Change OC1A Values!");
	LDD  R30,Y+21
	CPI  R30,0
	BRNE _0x4A
	__POINTW2MN _0x3,10
	CALL _lcd_puts
; 0000 0107 		if(pwm_channel==oc1b_pwm_channel) lcd_puts("Change OC1B Values!");
_0x4A:
	LDD  R26,Y+21
	CPI  R26,LOW(0x1)
	BRNE _0x4B
	__POINTW2MN _0x3,30
	CALL _lcd_puts
; 0000 0108 		if(pwm_channel==oc1c_pwm_channel) lcd_puts("Change OC1C Values!");
_0x4B:
	LDD  R26,Y+21
	CPI  R26,LOW(0x2)
	BRNE _0x4C
	__POINTW2MN _0x3,50
	CALL _lcd_puts
; 0000 0109 		if(pwm_channel==pa0_pwm_channel)  lcd_puts("Change PA0 Values!");
_0x4C:
	LDD  R26,Y+21
	CPI  R26,LOW(0x3)
	BRNE _0x4D
	__POINTW2MN _0x3,70
	CALL _lcd_puts
; 0000 010A 		lcd_gotoxy(0,1);
_0x4D:
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(1)
	CALL _lcd_gotoxy
; 0000 010B 		lcd_puts("OC..1A.1B.1C  PA0");
	__POINTW2MN _0x3,89
	CALL _lcd_puts
; 0000 010C 		lcd_gotoxy(0,2);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(2)
	CALL SUBOPT_0xD
; 0000 010D 		sprintf(lcd_str,"f=  %2d %2d %2d  %2d kHz",freq1,freq1,freq1,freq0);
	__POINTW1FN _0x0,107
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0xE
	CALL SUBOPT_0xE
	CALL SUBOPT_0xE
	MOV  R30,R4
	CALL SUBOPT_0xF
	CALL SUBOPT_0x10
; 0000 010E 		lcd_puts(lcd_str);
; 0000 010F 		lcd_gotoxy(0,3);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R26,LOW(3)
	CALL SUBOPT_0xD
; 0000 0110 		sprintf(lcd_str,"DC= %2d %2d %2d  %2d %%",oc1a_duty_cycle,oc1b_duty_cycle,oc1c_duty_cycle,pa0_duty_cycle);
	__POINTW1FN _0x0,132
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R17
	CALL SUBOPT_0xF
	MOV  R30,R16
	CALL SUBOPT_0xF
	MOV  R30,R19
	CALL SUBOPT_0xF
	MOV  R30,R18
	CALL SUBOPT_0xF
	CALL SUBOPT_0x10
; 0000 0111 		lcd_puts(lcd_str);
; 0000 0112 		delay_ms(50);
	CALL SUBOPT_0xA
; 0000 0113 	}
	RJMP _0x4
; 0000 0114 }
_0x4E:
	RJMP _0x4E
; .FEND

	.DSEG
_0x3:
	.BYTE 0x6B
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_put_buff_G100:
; .FSTART _put_buff_G100
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
_0x2000013:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2000014
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
_0x2000014:
	RJMP _0x2000015
_0x2000010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2000015:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
; .FEND
__print_G100:
; .FSTART __print_G100
	ST   -Y,R27
	ST   -Y,R26
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0x2000018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200001C
	CPI  R18,37
	BRNE _0x200001D
	LDI  R17,LOW(1)
	RJMP _0x200001E
_0x200001D:
	CALL SUBOPT_0x11
_0x200001E:
	RJMP _0x200001B
_0x200001C:
	CPI  R30,LOW(0x1)
	BRNE _0x200001F
	CPI  R18,37
	BRNE _0x2000020
	CALL SUBOPT_0x11
	RJMP _0x20000CC
_0x2000020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000021
	LDI  R16,LOW(1)
	RJMP _0x200001B
_0x2000021:
	CPI  R18,43
	BRNE _0x2000022
	LDI  R20,LOW(43)
	RJMP _0x200001B
_0x2000022:
	CPI  R18,32
	BRNE _0x2000023
	LDI  R20,LOW(32)
	RJMP _0x200001B
_0x2000023:
	RJMP _0x2000024
_0x200001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2000025
_0x2000024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000026
	ORI  R16,LOW(128)
	RJMP _0x200001B
_0x2000026:
	RJMP _0x2000027
_0x2000025:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0x200001B
_0x2000027:
	CPI  R18,48
	BRLO _0x200002A
	CPI  R18,58
	BRLO _0x200002B
_0x200002A:
	RJMP _0x2000029
_0x200002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001B
_0x2000029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x200002F
	CALL SUBOPT_0x12
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	LDD  R26,Z+4
	ST   -Y,R26
	CALL SUBOPT_0x13
	RJMP _0x2000030
_0x200002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2000032
	CALL SUBOPT_0x12
	CALL SUBOPT_0x14
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000033
_0x2000032:
	CPI  R30,LOW(0x70)
	BRNE _0x2000035
	CALL SUBOPT_0x12
	CALL SUBOPT_0x14
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2000036
_0x2000035:
	CPI  R30,LOW(0x64)
	BREQ _0x2000039
	CPI  R30,LOW(0x69)
	BRNE _0x200003A
_0x2000039:
	ORI  R16,LOW(4)
	RJMP _0x200003B
_0x200003A:
	CPI  R30,LOW(0x75)
	BRNE _0x200003C
_0x200003B:
	LDI  R30,LOW(_tbl10_G100*2)
	LDI  R31,HIGH(_tbl10_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x200003D
_0x200003C:
	CPI  R30,LOW(0x58)
	BRNE _0x200003F
	ORI  R16,LOW(8)
	RJMP _0x2000040
_0x200003F:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x2000071
_0x2000040:
	LDI  R30,LOW(_tbl16_G100*2)
	LDI  R31,HIGH(_tbl16_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x200003D:
	SBRS R16,2
	RJMP _0x2000042
	CALL SUBOPT_0x12
	CALL SUBOPT_0x15
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000043
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2000043:
	CPI  R20,0
	BREQ _0x2000044
	SUBI R17,-LOW(1)
	RJMP _0x2000045
_0x2000044:
	ANDI R16,LOW(251)
_0x2000045:
	RJMP _0x2000046
_0x2000042:
	CALL SUBOPT_0x12
	CALL SUBOPT_0x15
_0x2000046:
_0x2000036:
	SBRC R16,0
	RJMP _0x2000047
_0x2000048:
	CP   R17,R21
	BRSH _0x200004A
	SBRS R16,7
	RJMP _0x200004B
	SBRS R16,2
	RJMP _0x200004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x200004D
_0x200004C:
	LDI  R18,LOW(48)
_0x200004D:
	RJMP _0x200004E
_0x200004B:
	LDI  R18,LOW(32)
_0x200004E:
	CALL SUBOPT_0x11
	SUBI R21,LOW(1)
	RJMP _0x2000048
_0x200004A:
_0x2000047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x200004F
_0x2000050:
	CPI  R19,0
	BREQ _0x2000052
	SBRS R16,3
	RJMP _0x2000053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2000054
_0x2000053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2000054:
	CALL SUBOPT_0x11
	CPI  R21,0
	BREQ _0x2000055
	SUBI R21,LOW(1)
_0x2000055:
	SUBI R19,LOW(1)
	RJMP _0x2000050
_0x2000052:
	RJMP _0x2000056
_0x200004F:
_0x2000058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x200005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x200005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x200005A
_0x200005C:
	CPI  R18,58
	BRLO _0x200005D
	SBRS R16,3
	RJMP _0x200005E
	SUBI R18,-LOW(7)
	RJMP _0x200005F
_0x200005E:
	SUBI R18,-LOW(39)
_0x200005F:
_0x200005D:
	SBRC R16,4
	RJMP _0x2000061
	CPI  R18,49
	BRSH _0x2000063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2000062
_0x2000063:
	RJMP _0x20000CD
_0x2000062:
	CP   R21,R19
	BRLO _0x2000067
	SBRS R16,0
	RJMP _0x2000068
_0x2000067:
	RJMP _0x2000066
_0x2000068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2000069
	LDI  R18,LOW(48)
_0x20000CD:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x200006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	CALL SUBOPT_0x13
	CPI  R21,0
	BREQ _0x200006B
	SUBI R21,LOW(1)
_0x200006B:
_0x200006A:
_0x2000069:
_0x2000061:
	CALL SUBOPT_0x11
	CPI  R21,0
	BREQ _0x200006C
	SUBI R21,LOW(1)
_0x200006C:
_0x2000066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2000059
	RJMP _0x2000058
_0x2000059:
_0x2000056:
	SBRS R16,0
	RJMP _0x200006D
_0x200006E:
	CPI  R21,0
	BREQ _0x2000070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL SUBOPT_0x13
	RJMP _0x200006E
_0x2000070:
_0x200006D:
_0x2000071:
_0x2000030:
_0x20000CC:
	LDI  R17,LOW(0)
_0x200001B:
	RJMP _0x2000016
_0x2000018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,20
	RET
; .FEND
_sprintf:
; .FSTART _sprintf
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	CALL SUBOPT_0x16
	SBIW R30,0
	BRNE _0x2000072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x2080002
_0x2000072:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	CALL SUBOPT_0x16
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R26,R28
	ADIW R26,10
	RCALL __print_G100
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x2080002:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET
; .FEND
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C
	.EQU __sm_adc_noise_red=0x08
	.SET power_ctrl_reg=mcucr
	#endif

	.DSEG

	.CSEG
__lcd_write_nibble_G101:
; .FSTART __lcd_write_nibble_G101
	ST   -Y,R26
	LD   R30,Y
	ANDI R30,LOW(0x10)
	BREQ _0x2020004
	LDS  R30,101
	ORI  R30,4
	RJMP _0x202001D
_0x2020004:
	LDS  R30,101
	ANDI R30,0xFB
_0x202001D:
	STS  101,R30
	LD   R30,Y
	ANDI R30,LOW(0x20)
	BREQ _0x2020006
	SBI  0x15,7
	RJMP _0x2020007
_0x2020006:
	CBI  0x15,7
_0x2020007:
	LD   R30,Y
	ANDI R30,LOW(0x40)
	BREQ _0x2020008
	SBI  0x15,6
	RJMP _0x2020009
_0x2020008:
	CBI  0x15,6
_0x2020009:
	LD   R30,Y
	ANDI R30,LOW(0x80)
	BREQ _0x202000A
	SBI  0x15,5
	RJMP _0x202000B
_0x202000A:
	CBI  0x15,5
_0x202000B:
	__DELAY_USB 13
	SBI  0x15,3
	__DELAY_USB 13
	CBI  0x15,3
	__DELAY_USB 13
	RJMP _0x2080001
; .FEND
__lcd_write_data:
; .FSTART __lcd_write_data
	ST   -Y,R26
	LD   R26,Y
	RCALL __lcd_write_nibble_G101
    ld    r30,y
    swap  r30
    st    y,r30
	LD   R26,Y
	RCALL __lcd_write_nibble_G101
	__DELAY_USB 133
	RJMP _0x2080001
; .FEND
_lcd_gotoxy:
; .FSTART _lcd_gotoxy
	ST   -Y,R26
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G101)
	SBCI R31,HIGH(-__base_y_G101)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R26,R30
	RCALL __lcd_write_data
	LDD  R8,Y+1
	LDD  R11,Y+0
	ADIW R28,2
	RET
; .FEND
_lcd_clear:
; .FSTART _lcd_clear
	LDI  R26,LOW(2)
	CALL SUBOPT_0x17
	LDI  R26,LOW(12)
	RCALL __lcd_write_data
	LDI  R26,LOW(1)
	CALL SUBOPT_0x17
	LDI  R30,LOW(0)
	MOV  R11,R30
	MOV  R8,R30
	RET
; .FEND
_lcd_putchar:
; .FSTART _lcd_putchar
	ST   -Y,R26
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BREQ _0x2020011
	CP   R8,R10
	BRLO _0x2020010
_0x2020011:
	LDI  R30,LOW(0)
	ST   -Y,R30
	INC  R11
	MOV  R26,R11
	RCALL _lcd_gotoxy
	LD   R26,Y
	CPI  R26,LOW(0xA)
	BRNE _0x2020013
	RJMP _0x2080001
_0x2020013:
_0x2020010:
	INC  R8
	SBI  0x1B,4
	LD   R26,Y
	RCALL __lcd_write_data
	CBI  0x1B,4
	RJMP _0x2080001
; .FEND
_lcd_puts:
; .FSTART _lcd_puts
	ST   -Y,R27
	ST   -Y,R26
	ST   -Y,R17
_0x2020014:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2020016
	MOV  R26,R17
	RCALL _lcd_putchar
	RJMP _0x2020014
_0x2020016:
	LDD  R17,Y+0
	ADIW R28,3
	RET
; .FEND
_lcd_init:
; .FSTART _lcd_init
	ST   -Y,R26
	LDS  R30,100
	ORI  R30,4
	STS  100,R30
	SBI  0x14,7
	SBI  0x14,6
	SBI  0x14,5
	SBI  0x14,3
	SBI  0x1A,4
	SBI  0x1A,5
	CBI  0x15,3
	CBI  0x1B,4
	CBI  0x1B,5
	LDD  R10,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G101,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G101,3
	LDI  R26,LOW(20)
	LDI  R27,0
	CALL _delay_ms
	CALL SUBOPT_0x18
	CALL SUBOPT_0x18
	CALL SUBOPT_0x18
	LDI  R26,LOW(32)
	RCALL __lcd_write_nibble_G101
	__DELAY_USW 200
	LDI  R26,LOW(40)
	RCALL __lcd_write_data
	LDI  R26,LOW(4)
	RCALL __lcd_write_data
	LDI  R26,LOW(133)
	RCALL __lcd_write_data
	LDI  R26,LOW(6)
	RCALL __lcd_write_data
	RCALL _lcd_clear
_0x2080001:
	ADIW R28,1
	RET
; .FEND

	.CSEG

	.CSEG
_strlen:
; .FSTART _strlen
	ST   -Y,R27
	ST   -Y,R26
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
; .FEND
_strlenf:
; .FSTART _strlenf
	ST   -Y,R27
	ST   -Y,R26
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret
; .FEND

	.DSEG
__base_y_G101:
	.BYTE 0x4

	.CSEG
;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:125 WORDS
SUBOPT_0x0:
	MOV  R30,R17
	LDI  R31,0
	CALL __CWD1
	CALL __CDF1
	__GETD2N 0x3C23D70A
	CALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(1023)
	LDI  R31,HIGH(1023)
	SUB  R30,R6
	SBC  R31,R7
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL __MULF12
	MOVW R26,R6
	CLR  R24
	CLR  R25
	CALL __CDF2
	CALL __ADDF12
	CALL __CFD1U
	MOVW R20,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:129 WORDS
SUBOPT_0x1:
	MOV  R30,R16
	LDI  R31,0
	CALL __CWD1
	CALL __CDF1
	__GETD2N 0x3C23D70A
	CALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(1023)
	LDI  R31,HIGH(1023)
	SUB  R30,R6
	SBC  R31,R7
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL __MULF12
	MOVW R26,R6
	CLR  R24
	CLR  R25
	CALL __CDF2
	CALL __ADDF12
	CALL __CFD1U
	STD  Y+25,R30
	STD  Y+25+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:129 WORDS
SUBOPT_0x2:
	MOV  R30,R19
	LDI  R31,0
	CALL __CWD1
	CALL __CDF1
	__GETD2N 0x3C23D70A
	CALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	LDI  R30,LOW(1023)
	LDI  R31,HIGH(1023)
	SUB  R30,R6
	SBC  R31,R7
	CLR  R22
	CLR  R23
	CALL __CDF1
	CALL __MULF12
	MOVW R26,R6
	CLR  R24
	CLR  R25
	CALL __CDF2
	CALL __ADDF12
	CALL __CFD1U
	STD  Y+23,R30
	STD  Y+23+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:37 WORDS
SUBOPT_0x3:
	MOV  R30,R18
	LDI  R31,0
	CALL __CWD1
	CALL __CDF1
	__GETD2N 0x3C23D70A
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:21 WORDS
SUBOPT_0x4:
	MOV  R30,R9
	LDI  R31,0
	LDI  R26,LOW(255)
	LDI  R27,HIGH(255)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x5:
	CALL __CWD1
	CALL __CDF1
	CALL __MULF12
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:25 WORDS
SUBOPT_0x6:
	CALL __CWD2
	CALL __CDF2
	CALL __ADDF12
	CALL __CFD1U
	STD  Y+22,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x7:
	MOV  R30,R21
	ANDI R31,HIGH(0x0)
	OUT  0x2B,R30
	MOV  R30,R20
	OUT  0x2A,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x8:
	LDD  R30,Y+26
	ANDI R31,HIGH(0x0)
	OUT  0x29,R30
	LDD  R30,Y+25
	OUT  0x28,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x9:
	LDD  R30,Y+24
	STS  121,R30
	LDD  R30,Y+23
	STS  120,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0xA:
	LDI  R26,LOW(50)
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0xB:
	MOV  R26,R5
	LDI  R27,0
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	CALL __MULW12
	CALL __CWD1
	__GETD2N 0xF4240
	CALL __DIVD21
	LDI  R26,LOW(1023)
	LDI  R27,HIGH(1023)
	SUB  R26,R30
	SBC  R27,R31
	MOVW R6,R26
	RJMP SUBOPT_0x0

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:14 WORDS
SUBOPT_0xC:
	MOV  R26,R4
	LDI  R27,0
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	CALL __MULW12
	CALL __CWD1
	__GETD2N 0xF4240
	CALL __DIVD21
	LDI  R26,LOW(255)
	SUB  R26,R30
	MOV  R9,R26
	MOV  R30,R9
	LDI  R31,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xD:
	CALL _lcd_gotoxy
	MOVW R30,R28
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:5 WORDS
SUBOPT_0xE:
	MOV  R30,R5
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0xF:
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x10:
	LDI  R24,16
	CALL _sprintf
	ADIW R28,20
	MOVW R26,R28
	JMP  _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:13 WORDS
SUBOPT_0x11:
	ST   -Y,R18
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x12:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:3 WORDS
SUBOPT_0x13:
	LDD  R26,Y+13
	LDD  R27,Y+13+1
	LDD  R30,Y+15
	LDD  R31,Y+15+1
	ICALL
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x14:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x15:
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x16:
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x17:
	CALL __lcd_write_data
	LDI  R26,LOW(3)
	LDI  R27,0
	JMP  _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x18:
	LDI  R26,LOW(48)
	CALL __lcd_write_nibble_G101
	__DELAY_USW 200
	RET


	.CSEG
_delay_ms:
	adiw r26,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r26,1
	brne __delay_ms0
__delay_ms1:
	ret

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__CWD2:
	MOV  R24,R27
	ADD  R24,R24
	SBC  R24,R24
	MOV  R25,R24
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVD21U:
	PUSH R19
	PUSH R20
	PUSH R21
	CLR  R0
	CLR  R1
	CLR  R20
	CLR  R21
	LDI  R19,32
__DIVD21U1:
	LSL  R26
	ROL  R27
	ROL  R24
	ROL  R25
	ROL  R0
	ROL  R1
	ROL  R20
	ROL  R21
	SUB  R0,R30
	SBC  R1,R31
	SBC  R20,R22
	SBC  R21,R23
	BRCC __DIVD21U2
	ADD  R0,R30
	ADC  R1,R31
	ADC  R20,R22
	ADC  R21,R23
	RJMP __DIVD21U3
__DIVD21U2:
	SBR  R26,1
__DIVD21U3:
	DEC  R19
	BRNE __DIVD21U1
	MOVW R30,R26
	MOVW R22,R24
	MOVW R26,R0
	MOVW R24,R20
	POP  R21
	POP  R20
	POP  R19
	RET

__DIVD21:
	RCALL __CHKSIGND
	RCALL __DIVD21U
	BRTC __DIVD211
	RCALL __ANEGD1
__DIVD211:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__CHKSIGND:
	CLT
	SBRS R23,7
	RJMP __CHKSD1
	RCALL __ANEGD1
	SET
__CHKSD1:
	SBRS R25,7
	RJMP __CHKSD2
	CLR  R0
	COM  R26
	COM  R27
	COM  R24
	COM  R25
	ADIW R26,1
	ADC  R24,R0
	ADC  R25,R0
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSD2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__CDF2U:
	SET
	RJMP __CDF2U0
__CDF2:
	CLT
__CDF2U0:
	RCALL __SWAPD12
	RCALL __CDF1U0

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
